
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>将Oracle内置的安全特性用于php / iVAN</title>

    <meta name="description" content="将Oracle内置的安全特性用于php 当今大多数 Web 应用程序都需要至少采用某种基本的安全策略.例如,提供用口令保护的内容的网站.仅具有管理员后端的网站.网志和个人杂志.电子商务网站.企业内联网,等等. 构建这些类型的 Web 应用程序最常用的设计方法是将安全策略整合到 Web 应用程序的业务逻辑中,即由应用程序决定某个用户是否有权访问数据库中的某个数据.在这种情形下,数据库的角色仅为存储数据和依请求提供数据.换句话说,如果 Web 应用程序命令数据库提供特定信息,则数据库会直接执行该命令而不检查用户的权限. 在该文中,您将学习">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">将Oracle内置的安全特性用于php</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>　　当今大多数 Web 应用程序都需要至少采用某种基本的安全策略。例如，提供用口令保护的内容的网站、仅具有管理员后端的网站、网志和个人杂志、电子商务网站、企业内联网，等等。 <br />　　</p>
<p>　　构建这些类型的 Web 应用程序最常用的设计方法是将安全策略整合到 Web 应用程序的业务逻辑中，即由应用程序决定某个用户是否有权访问数据库中的某个数据。在这种情形下，数据库的角色仅为存储数据和依请求提供数据。换句话说，如果 Web 应用程序命令数据库提供特定信息，则数据库会直接执行该命令而不检查用户的权限。</p>
<p>　　在该文中，您将学习如何利用 Oracle 内置的安全特性在数据库级执行应用程序安全规则，以提高应用程序的整体安全性。作为附带的好处，直接在数据库中实现数据访问安全不但有助于提高应用程的安全性，而且有助于降低复杂性。</p>
<p>　　对数据库端安全性的需求</p>
<p>　　从 Web 应用程序控制数据访问会怎么样？大多数情况下没有问题；这是个不错的解决方案，尤其是在涉及的数据为非任务关键或绝密的时候。许多书和在线资源中都用到了该方法。实际上，有本很受欢迎的 PHP/MySQL 书明确反对每个应用程序创建一个以上的数据库用户帐户，这是因为“额外的用户或复杂的权限会因某个操作在继续前要检查更多的信息而降低 MySQL 的执行速度”。确实如此；但是，在放弃将安全性整合到数据库逻辑中的想法前可能要考虑几件事情。我们来看以下示例。</p>
<p>　　假设创建一个内容管理系统 (CMS)。其中使用数据库来存储网站上发布的内容。大部分数据是公开的，允许匿名 Web 用户读取；但只允许编辑更改数据。使用单一数据库帐户访问和修改数据库中的记录，并通过用口令保护仅管理员可以访问的页面的访问权限用 PHP 代码控制安全性。</p>
<p>　　如果 Web 应用程序的公共端遭受了一个诸如公共搜索表单（即编码不够严密的表单）上的 SQL 注入的攻击，则该入侵者可能能够对该公共帐户可以访问的数据库对象执行任意 SQL 语句。当然，就这里的情形而言，执行 SELECT 语句不会造成什么大问题，这是因为数据本来就是公共的。但由于公共权限和管理权限使用同一数据库帐户，因此入侵者还能执行 UPDATE 和 DELETE 语句，甚至是从数据库中删除表。</p>
<p>　　怎么才能防止该情况的发生呢？最简单的方法就是彻底限制公共数据库帐户修改数据的权限。我们来看看 Oracle 是如何解决这个问题的。</p>
<p>　　Oracle 安全性基本概述</p>
<p>　　Oracle 数据库为 Web 开发人员提供了控制数据访问的许多方法，从管理对特定数据库对象（如表、视图和过程）的访问到控制个别行或列的数据的访问。很显然，对 Oracle 每个安全特性或可用选项的讨论超出了本文的范围。在这里，我们将不涉及过多细节，而仅介绍 Oracle 数据访问安全性的最基本方面：</p>
<p>　　验证和用户帐户</p>
<p>　　权限</p>
<p>　　角色</p>
<p>　　验证和用户帐户。 与其他数据库一样，请求访问 Oracle 的每个用户（数据库帐户）必须通过验证。验证工作可以由数据库、操作系统或网络服务来做。除基本的验证（口令验证）外，Oracle 还支持强验证机制，如Kerberos、CyberSafe、RADIUS，等等。</p>
<p>　　角色。 Oracle 角色是一个权限的有名集。尽管可以直接授予用户帐户权限，但使用角色可以极大简化用户管理，尤其是需要管理大量用户时。创建易管理的小角色，然后根据用户的安全级别授予用户一个或多个角色，这样做的效率非常高。更不用说修改权限变得如何简单了 — 只需修改角色关联的角色即可，无需修改每个用户帐户。</p>
<p>　　为了简化新用户创建初期的工作，Oracle 自带了三个预定义的角色：</p>
<p>　　CONNECT 角色 — 该角色使用户可以连接数据库以及执行基本的操作，如创建自己的表。默认情况下，该角色不能访问其他用户的表。</p>
<p>　　RESOURCE 角色 — RESOURCE 角色与 CONNECT 角色相似，但它允许用户拥有较多的系统权限，如创建触发器或存储过程。</p>
<p>　　DBA 角色 — 允许用户拥有所有系统权限。</p>
<p>　　使用中的授权和权限</p>
<p>　　在本部分中，我们将讨论如何使用 Oracle 的授权和权限来提高本文开头部分讨论的那个简单 CMS 示例的安全性。假定，提供给应用程序用户的内容存储在 WEB_CONTENT 表中。</p>
<p>　　首先，创建该表。启动 Oracle 数据库特别版，以系统管理员身份登录。如果还没有释放示例 HR 用户，请将其释放。按照特别版安装附带的入门指南中的指示操作。请注意，默认情况下，HR 用户被赋予 RESOURCE 角色。在这里，赋予该用户 DBA 角色，这样就可以使用该帐户管理 CMS 应用程序的数据库方面了。当然，不会使用 HR 用户帐户进行在线访问，只用它管理数据库。</p>
<p>　　现在，可以使用对象浏览器或通过执行 SQL Commands 窗口创建新表。下面是创建该表的代码：</p>
<p>　　CREATE TABLE WEB_CONTENT (</p>
<p>　　page_id NUMBER PRIMARY KEY,</p>
<p>　　page_content VARCHAR2(255)</p>
<p>　　);</p>
<p>　　由于该表是使用 HR 用户帐户创建的，因此该表归 HR 帐户所有并位于 HR 模式中，并且在明确授予其他用户访问该表的权限前，其他用户无法访问该表。如果不信，可以创建一个新用户，用该用户访问 WEB_CONTENT 表试试。</p>
<p>　　现在，创建两个新用户，CMS_USER 和 CMS_EDITOR。最终，将授予 CMS_USER 对 WEB_CONTENT 表的只读权限，并将该用户用作为匿名 Web 用户提供内容的数据库帐户。CMS_EDITOR 帐户将在该表上拥有更多权限，将被用作 CMS 编辑的帐户（该帐户需要更改和维护该表中的数据）。</p>
<p>　　可以使用 XE 的图形界面或通过执行以下命令创建新用户：</p>
<p>　　CREATE USER cms_user IDENTIFIED BY cms_user;</p>
<p>　　CREATE USER cms_editor IDENTIFIED BY cms_editor;</p>
<p>　　（出于简化的目的，此处的口令与用户名对应。）</p>
<p>　　为了让这两个帐户都登录数据库，我们需要赋予它们 CONNECT 角色。为此，在 XE 图形界面的 Administration/Database Users 部分选中用户信息下的 CONNECT 复选框，或执行以下命令：</p>
<p>　　GRANT CONNECT to cms_user;</p>
<p>　　GRANT CONNECT to cms_editor;</p>
<p>　　现在，如果尝试以 CMS_USER 或 CMS_EDITOR 用户登录并试图从 WEB_CONTENT 表读取数据 (select * from hr.web_content;)，将遇到以下错误：</p>
<p>　　ORA-00942:table or view does not exist</p>
<p>　　为了访问数据或仅是看到表，需要授予 CMS_USER 和 CMS_EDITOR 帐户对 WEB_CONTENT 表的只读权限：</p>
<p>　　GRANT SELECT on hr.web_content to cms_user;</p>
<p>　　GRANT SELECT on hr.web_content to cms_editor;</p>
<p>　　以上代码使这两个帐户可以对 WEB_CONTENT 表执行 SELECT 语句。如果尝试执行其他语句，则会遇到错误。例如，插入一行：</p>
<p>　　INSERT INTO hr.web_content (page_id,page_content) VALUES (1,'hello world');</p>
<p>　　将产生错误消息</p>
<p>　　ORA-01031:insufficient privileges</p>
<p>　　要允许 CMS_EDITOR 更改该表的内容，需要授予以下权限：</p>
<p>　　GRANT INSERT,UPDATE,DELETE on hr.web_content to cms_editor;</p>
<p>　　从现在起，CMS_EDITOR 帐户可以对 WEB_CONTENT 表执行 INSERT、UPDATE 和 DELETE 语句。</p>
<p>　　您看，这有多简单！可见通过角色管理权限是更有效的方法。如果使用的 Oracle 数据库不是 XE，可以执行如下操作：</p>
<p>　　创建角色：</p>
<p>　　CREATE ROLE reader;</p>
<p>　　CREATE ROLE writer;</p>
<p>　　授予角色权限：</p>
<p>　　GRANT SELECT ON web_content TO reader;</p>
<p>　　GRANT INSERT,UPDATE,DELETE ON web_content TO writer;</p>
<p>　　赋予用户角色：</p>
<p>　　GRANT reader TO cms_user;</p>
<p>　　GRANT reader TO cms_editor; (they need to read too)</p>
<p>　　GRANT writer TO cms_editor;</p>
<p>　　请注意，如果更改 READER 角色的定义，则这些更改会影响所有具有该角色的用户帐户。如果是直接将权限授予用户的，则必须逐个更新每个用户帐户。</p>
<p>　　完成上述步骤后，可以配置 PHP 应用程序，使之对由匿名 Web 用户请求的所有数据库连接均使用 CMS_USER 帐户，对由受口令保护的管理页面引发的连接使用 CMS_EDITOR 帐户。现在，即使公共 Web 表单受到攻击，该攻击对数据库的影响将微乎其微，这是因为 CMS_USER 帐户仅具有只读权限。</p>
<p>　　结论</p>
<p>　　在本文中，我们只是简单介绍了 Oracle 数据访问安全性的一些最基本的特性。此外，Oracle 还有许多其他特性，可把您的 Web 应用程序的安全性提高到一个新的等级 — 包括虚拟专用数据库 (VPD) 和标签安全性。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 07:32:50</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9d%83%e9%99%90/" title="权限">权限</a>, <a href="https://www.iamivan.net/tag/%e7%94%a8%e6%88%b7/" title="用户">用户</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae/" title="数据">数据</a>, <a href="https://www.iamivan.net/tag/%e5%ba%94%e7%94%a8%e7%a8%8b%e5%ba%8f/" title="应用程序">应用程序</a>, <a href="https://www.iamivan.net/tag/%e8%a7%92%e8%89%b2/" title="角色">角色</a>, <a href="https://www.iamivan.net/tag/cms/" title="cms">cms</a>, <a href="https://www.iamivan.net/tag/cms%c2%a0oa%c2%a0%e7%94%a8%e6%88%b7%e6%9d%83%e9%99%90%c2%a0/" title="CMS&nbsp;OA&nbsp;用户权限&nbsp;">CMS&nbsp;OA&nbsp;用户权限&nbsp;</a>, <a href="https://www.iamivan.net/tag/web%c2%a0page%c2%a0editor/" title="web&nbsp;page&nbsp;editor">web&nbsp;page&nbsp;editor</a>, <a href="https://www.iamivan.net/tag/php%e4%b8%ad%e7%9a%84cms%e7%9a%84%e6%b6%b5%e4%b9%89/" title="PHP中的CMS的涵义">PHP中的CMS的涵义</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>将Oracle内置的安全特性用于php的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XMly8px.html" rel="bookmark">将 Oracle 内置的安全特性用于 PHP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当今大多数 Web 应用程序都需要至少采用某种基本的安全策略.例如,提供用口令保护的内容的网站.仅具有管理员后端的网站.网志和个人杂志.电子商务网站.企业内联网,等等. 构建这些类型的 Web 应用程序最常用的设计方法是将安全策略整合到 Web 应用程序的业务逻辑中,即由应用程序决定某个用户是否有权访问数据库中的某个数据.在这种情形下,数据库的角色仅为存储数据和依请求提供数据.换句话说,如果 Web 应用程序命令数据库提供特定信息,则数据库会直接执行该命令而不检查用户的权限. 在该文中,您将学习			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMrjxMK.html" rel="bookmark">将Oracle 10g内置的安全特性用于PHP</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当今大多数 Web 应用程序都需要至少采用某种基本的安全策略.例如,提供用口令保护的内容的网站.仅具有管理员后端的网站.网志和个人杂志.电子商务网站.企业内联网,等等. 构建这些类型的 Web 应用程序最常用的设计方法是将安全策略整合到 Web 应用程序的业务逻辑中,即由应用程序决定某个用户是否有权访问数据库中的某个数据.在这种情形下,数据库的角色仅为存储数据和依请求提供数据.换句话说,如果 Web 应用程序命令数据库提供特定信息,则数据库会直接执行该命令而不检查用户的权限. 在该文中,您将学习			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMggEOM.html" rel="bookmark">Oracle SQL 内置函数的使用方法及结果</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SQL中的单记录函数 1.ASCII 返回与指定的字符对应的十进制数; SQL&gt; select ascii('A') A,ascii('a') a,ascii('0') zero,ascii(' ') space from dual; A A ZERO SPACE --------- --------- --------- --------- 65 97 48 32 2.CHR 给出整数,返回对应的字符; SQL&gt; select chr(54740) zhao,chr(65) chr65 fr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW7ljAM.html" rel="bookmark">javascript 内置对象及常见API详细介绍&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一. 类与对象    在 JavaScript世界里,关于面向对象第一个要澄清的概念就是类.对象都是由类来定义的,通过类来创建对象就是我们所熟悉的实例化.然而,在 JavaScript中别没有真正的类,对象的定义就是对象自身.而 ECMA-262 干脆把这种妥协的方式称作为对象的调和剂.为了方便理解,我通常把这个发挥类的作用的调和剂称为类.    Javascript内置对象学习 全局属性 Infinity 表示正无穷大的数值 NaN 非数字值 undefined 未定义的值 decodeURI			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvm0LNb.html" rel="bookmark">Oracle中REGEXP&lowbar;SUBSTR及其它支持正则表达式的内置函数小结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Oracle中REGEXP_SUBSTR函数的使用说明: 题目如下:在oracle中,使用一条语句实现将'17,20,23'拆分成'17','20','23'的集合. REGEXP_SUBSTR函数格式如下:function REGEXP_SUBSTR(String, pattern, position, occurrence, modifier)__srcstr :需要进行正则处理的字符串__pattern :进行匹配的正则表达式,匹配的值将返回,返回策略由__occurrence决定__po			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9bBwDaM.html" rel="bookmark">C&num; 2&period;0新特性探究之模拟泛型和内置算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				算法 在C#2.0中,匿名方法.IEnumerable接口和匿名方法的合作,使很多的编程任务变得非常的简单,而且写出来的程序非常的优美. 比如,我们可以写出如下的代码: List&lt;Book&gt; thelib = Library.getbooks(); List&lt;Book&gt; found = thelib.FindAll(delegate(Book curbook) { if (curbook.isbn.StartsWith(&quot;...&quot;)) return true;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze4oj8p.html" rel="bookmark">用于启动 Windows Phone 8 内置应用的 URI 方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本主题列出了可用于启动内置应用的 URI 方案.许多内置于 Windows Phone 的应用,都可以通过调用 LaunchUriAsync(Uri) 和传入一个使用与要启动应用相关的方案的 URI,从您的应用启动.例如,以下调用可以启动蓝牙设置应用. Windows.System.Launcher.LaunchUriAsync(new Uri(&quot;ms-settings-bluetooth:&quot;)); 托管的应用 和 Direct3D 应用 都支持此内置应用启动方法. URI 方案列表			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY2mJep.html" rel="bookmark">Oracle如何用内置脚本查堵塞</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 在诊断关于锁的问题的时候,要查到持有者,被堵塞者.往往是很麻烦,如果你没有积累的脚本,靠手工查要查很多表,如v$lock,v$process p, v$session s, v$latchholder等.现在有个简单的方法,使用Oracle的内置脚本生成两个视图dba_waiters和dba_blockers来查堵塞.执行内置脚本要在SYS中执行,如下: C:Documents and Settingsguogang&gt;sqlplus / as sysdba; SQL*Plus: Release			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwLJ7p.html" rel="bookmark">PostgreSQL 在路上的特性 - 远离触发器&comma; 拥抱内置分区</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前分享过阿里云RDS PG支持分区表的文章https://yq.aliyun.com/articles/113今天要给大家带来另一个好消息,PostgreSQL 社区版本终于要有集成的分区表特性了,再也不用为写分区触发器烦恼了.(很多人认为PG现有的分区表用法是&quot;惨无人道&quot;的(除了管理不方便,性能也是个问题),就像是一粒老鼠屎,坏了一锅汤.社区终于要把老鼠屎请出去了.) 如果你不care性能,可以看看我以前写的一个通用的分区表触发器函数,一个函数打天下http://blog.163.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDqXb7.html" rel="bookmark" class="title">hdu 2054 A &equals;&equals; B&quest;</a>
					<div>
						http://acm.hdu.edu.cn/showproblem.php?pid=2054 此题巨坑,刚开始我以为是简单的水题,就用strcmp过, but错了,后来经过我苦思冥想,结果还有几组数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp52KRz.html" rel="bookmark" class="title">逐步排查 层层递进 解决IIS服务器报错</a>
					<div>
						IIS服务器出错的原因是复杂的.如服务启动失败.IIS进程中断或者站点不能启动这些错误都会在系统日志中记录一个错误事件.不论IIS出现何种错误,在确定排错方案之前,都应先使用事件查看器查阅系统日志所记 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwmKdM.html" rel="bookmark" class="title">Photoshop&colon;真实合成-论置换图的制作</a>
					<div>
						一直以来,用置换滤镜为MM换花衣,已经成为ps界比较公认的方法.其目的是希望衣料上的花纹图案随着褶皱发生扭曲变形.这个愿望是很好的,是一种进一步做出更好效果的追求. 但我不知道,大家是怎么做置换图的. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Xpm5Dwp.html" rel="bookmark" class="title">VB编辑ListView的SubItem</a>
					<div>
						文件一,Form1.frm 加入一个Listview,两个Imagelist,一个文本框 代码如下:Option Explicit'' Copyright ?1997-1999 Brad Martin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKKXEM.html" rel="bookmark" class="title">MVC、MVP以及Model2&lbrack;下篇&rsqb;</a>
					<div>
						[上篇]通过采用MVC模式,我们可以将可视化UI元素的呈现.UI处理逻辑和业务逻辑分别定义在View.Controller和Model中,但是对于三者之间的交互,MVC并没有进行严格的限制.最为典型的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2XQKb.html" rel="bookmark" class="title">Symbian学习笔记&lpar;7&rpar;&mdash;&mdash;定时器</a>
					<div>
						Symbian教材里说到活动对象时,总拿CTimer来做例子,从CActive派生一个CMyActive然后它包括一个CTimer iTimer,再利用它的异步函数iTimer.After来演示活动对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOw2k9z.html" rel="bookmark" class="title">mysql中文模糊检索问题</a>
					<div>
						在MySQL下,在进行中文模糊检索时,经常会返回一些与之不相关的记录,如查找 &quot;%a%&quot; 时,返回的可能有中文字符,却没有a字符存在.本人以前也曾遇到过类似问题,经详细阅读MySQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk216yM.html" rel="bookmark" class="title">Cocos2D-X入门（1） 制作一个动态的精灵</a>
					<div>
						原理: Cocos2D中有个导演控制整个游戏流程,导演将场景添加到屏幕上,场景中有各种各样的演员. 先通过显示一张图片来看看Cocos2D游戏的流程: AppDelegate.cpp bool App ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4yq0p.html" rel="bookmark" class="title">Linux系统init级别设置错误导致系统不能正常启动怎么办&quest;</a>
					<div>
						  Linux系统init级别设置错误导致系统不能正常启动怎么办? 1.在Linux启动过程中,按Esc键进入Grub界面. 2.按e修改当前Linux系统的配置. 3.选择第二行,按e键,并按如下步 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M627mJM.html" rel="bookmark" class="title">文档协作中分配文档的操作方法</a>
					<div>
						文档协作中分配文档的操作方法   图1 文档的拆分与合并 可以通过如下步骤轻松地将一个主文档分割成几个独立的子文档: 1.打开主文档,单击状态栏右侧的[大纲视图]按钮切换到大纲视图.如图2所示. 图2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jPelb.html" rel="bookmark" class="title">php通过curl模拟登陆DZ论坛</a>
					<div>
						  本文章来给各位同学介绍一下关于Php CURL模拟登陆论坛并采集数据实例,如果你对利用curl模拟登录功能有兴趣可进入参考. libcurl同时也支持HTTPS认证.HTTP POST.HTTP  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrL2Zp.html" rel="bookmark" class="title">Photoshop给公园人物调出淡冷色调</a>
					<div>
						图片主色为绿色,转蓝紫色的时候可以先降低图片的饱和度,得到近似黑白的效果,然后再用曲线等快速增加蓝紫色,后期把主色调淡即可. 原图 &lt;点小图查看大图&gt; 最终效果 1.打开素材图片,创建可选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8k4Zp.html" rel="bookmark" class="title">制作U盘启动的几个方法</a>
					<div>
						  制作U盘启动的几个方法          我们把U盘量产的一般目的都是为了启动,但要达到启动目的不一定要量产: 1.用UltraISO写入也可以启动电脑,缺点是很里面的文件可见可删除. 2.用老毛 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwoQKb.html" rel="bookmark" class="title">12招防Windwos XP蓝屏</a>
					<div>
						  经常用电脑的朋友一定没有少碰到蓝屏,那张冰凉的蓝面孔真的很令人讨厌.那么蓝屏到底是怎么产生的呢? 我们可以从软.硬两方面来解释蓝屏现象产生的原因.从硬件方面来说,超频过度是导致蓝屏的一个主要原因. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Znkxb.html" rel="bookmark" class="title">Springmvc &plus;JNDI 在Tomcat下 配置数据源（转）</a>
					<div>
						  一.             简介 jndi(Java Naming and Directory Interface,Java命名和目录接口)是一组在Java应用中访问命名和目录服务的API.命名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YmRXM.html" rel="bookmark" class="title">SecureCRT光标丢失问题</a>
					<div>
						  SecureCRT光标丢失问题 2013-09-24 11:11 11142人阅读 评论(2) 收藏 举报  分类: 工具使用(7)  版权声明:本文为博主原创文章,未经博主允许不得转载. Sec ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZQnBz.html" rel="bookmark" class="title">easyui  tree-js 从左边树向右边的树添加节点</a>
					<div>
						问题描述 js 从左边树向右边的树添加节点 实现左边勾选,点击添加后,右边出现勾选出来的树结构结果,不勾选的不显示 解决方案 easyui checkbox tree选择节点后添加到另外一棵树示例					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXql4Qz.html" rel="bookmark" class="title">有关rmi调用数据库的问题</a>
					<div>
						问题描述 最近在做一个rmi的程序,简单的Helloworld调用已经实现了,可是当我加入有数据库操作的方法,客户端又不能调用了,调试发现程序根本不走方法调用的语句,求高手指点! 解决方案 解决方案二 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeomAxM.html" rel="bookmark" class="title">简单的三级联动案例，供参考</a>
					<div>
						写个简单的三级联动案例,以地区来演示,供参考,大家注意下自己的jquery导入路径,如有不对的地方欢迎大家纠正. &lt;html&gt; &lt;head&gt; &lt;!--导入jquery-- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ReZAz.html" rel="bookmark" class="title">商业巨头是怎么玩转大数据的？</a>
					<div>
						在大数据推动的商业革命暗涌中,要么学会使用大数据的杠杆创造商业价值,要么被大http://www.aliyun.com/zixun/aggregation/13873.html&quot;&gt;数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkanlM.html" rel="bookmark" class="title">科骏达6062导航的WiCE5系统怎么重装&quest;</a>
					<div>
						问题描述 科骏达6062导航的WiCE5系统怎么重装? 导航是64M内存.文件误删除了,系统分区误删除了.WINCE5系统没有了,怎么重装?要安装包和安装说明. 解决方案 这种山寨的设备,最好咨询下厂 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJA53p.html" rel="bookmark" class="title">谷歌移动主管称Android是为谷歌广告做延伸</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 北京时间5月23日消息,据国外媒体报道,谷歌移动平台主管安迪·鲁宾(Andy Rubin)周四在接受外界采访时表示,从本质上看,谷歌Android手机操 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bod4xBM.html" rel="bookmark" class="title">帮我改改代码，让倒计时结束自动评分，为什么我做的不行啊？</a>
					<div>
						问题描述 &lt;html&gt;&lt;head&gt;&lt;metahttp-equiv=&quot;Content-Type&quot;content=&quot;text/html;char ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnXGJM.html" rel="bookmark" class="title">你写的邮件真的有效吗？</a>
					<div>
						电子邮件是现在创业团队以及互联网公司最常用的沟通方式.但是它的沟通效果到底如何?有什么禁忌和技巧,你又是否真的了解了?如何做到有效沟通,如何通过发送有效的电子邮件,确保你的沟通达到预期呢? 要想有效沟 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZ7E6p.html" rel="bookmark" class="title">去长沙培训JAVA软件工程师，哪个学校比较好？给点建议？</a>
					<div>
						问题描述 有没有培训过的?给点建议可否还有希望大家能够传授点JAVA学习心得经验给我我非常感谢. 解决方案 解决方案二:如果去培训的话:1.你应该先看看培训机构的就业率,以及历届学生的工资,我想这个应 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKd9vM.html" rel="bookmark" class="title">IOS设备上给body绑定click事件不生效的原因及解决办法&lowbar;IOS</a>
					<div>
						事件背景: 最近在做一个移动端业务的时候碰到一个bug,在ios上对body绑定click事实现事件代理冒泡至某些元素上尽然不生效. 思考: 暂借助jquery展示下事件绑定代码,将所有标签含有dat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgE976z.html" rel="bookmark" class="title">Android编程中Perferences的用法实例分析&lowbar;Android</a>
					<div>
						本文实例讲述了Android编程中Perferences的用法.分享给大家供大家参考,具体如下: 浏览手机的/data/data/目录中的各个package的目录,经常会看到有一个shared_pre ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7AQAM.html" rel="bookmark" class="title">oracle date 类型字段的处理方法&lowbar;oracle</a>
					<div>
						(1)在英文版本的ORACLE中默认日期格式为'DD-MON-YY',例如'01-JAN-98' 在汉化的中文版本中ORACLE默认日期格式为'日-月-年',例如'21-8月-2003'或'21-8月 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1qPOb.html" rel="bookmark" class="title">Android开发16&mdash;&mdash;获取网络资源之基础应用</a>
					<div>
						一.项目背景在Android开发中有一项非常广泛的应用:Android项目获取另一个web项目的资源或者返回的数据.本博文介绍了获取另一个web项目的资源.有一个web项目,在其WebRoot文件夹下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zen468b.html" rel="bookmark" class="title">ZIP文件中被压缩的字节如何用C&num;中现成的类给解码出来？请大神帮忙</a>
					<div>
						问题描述 ZIP文件的总体格式分文件头信息+文件压缩数据中心目录+中心目录记录结束符1.分文件头信息:字节数描述4分文件头信息标志(0x04034b50)2解压缩所需版本2通用比特标志位(置比特0位= ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
